/* clock.c generated by valac 0.56.17, the Vala compiler
 * generated from clock.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "clock.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "vala-panel.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>

#define CLOCK_TIP_FORMAT "tooltip-format"
#define CLOCK_LABEL_FORMAT "clock-format"
#define CLOCK_BOLD "bold-font"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	CLOCK_INTERVAL_AWAITING_FIRST_CHANGE = 0,
	CLOCK_INTERVAL_AWAITING_SECOND_CHANGE = 1,
	CLOCK_INTERVAL_ONE_SECOND = 2,
	CLOCK_INTERVAL_ONE_MINUTE = 3
} ClockInterval;

#define CLOCK_TYPE_INTERVAL (clock_interval_get_type ())
enum  {
	CLOCK_0_PROPERTY,
	CLOCK_CLOCK_FORMAT_PROPERTY,
	CLOCK_TOOLTIP_FORMAT_PROPERTY,
	CLOCK_BOLD_FONT_PROPERTY,
	CLOCK_NUM_PROPERTIES
};
static GParamSpec* clock_properties[CLOCK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _ClockPrivate {
	GtkToggleButton* clock;
	ClockInterval exp_interval;
	gint exp_count;
	gchar* prev_clock_val;
	guint timer;
	GtkWindow* calendar;
	gchar* _clock_format;
	gchar* _tooltip_format;
	gboolean _bold_font;
};

static gint Clock_private_offset;
static gpointer clock_parent_class = NULL;
static GType clock_type_id = 0;

static GType clock_interval_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void clock_real_constructed (GObject* base);
static void __lambda4_ (Clock* self);
static GtkWindow* clock_create_calendar (Clock* self);
static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda5_ (Clock* self,
                 GParamSpec* pspec);
static gchar* clock_get_css (Clock* self);
static void clock_timer_set (Clock* self,
                      GDateTime* current_time);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GtkWidget* clock_real_get_settings_ui (ValaPanelApplet* base);
static void clock_popup_position_helper (Clock* self,
                                  GtkWidget* popup,
                                  gint* x,
                                  gint* y);
static void clock_set_popup_position (Clock* self,
                               GtkWidget* popup);
VALA_EXTERN gboolean clock_get_bold_font (Clock* self);
static gboolean clock_update_display (Clock* self);
VALA_EXTERN const gchar* clock_get_clock_format (Clock* self);
VALA_EXTERN const gchar* clock_get_tooltip_format (Clock* self);
static gboolean _clock_update_display_gsource_func (gpointer self);
VALA_EXTERN void clock_set_clock_format (Clock* self,
                             const gchar* value);
VALA_EXTERN void clock_set_tooltip_format (Clock* self,
                               const gchar* value);
VALA_EXTERN void clock_set_bold_font (Clock* self,
                          gboolean value);
static void clock_finalize (GObject * obj);
static void _vala_clock_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_clock_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
clock_get_instance_private (Clock* self)
{
	return G_STRUCT_MEMBER_P (self, Clock_private_offset);
}

static GType
clock_interval_get_type_once (void)
{
	static const GEnumValue values[] = {{CLOCK_INTERVAL_AWAITING_FIRST_CHANGE, "CLOCK_INTERVAL_AWAITING_FIRST_CHANGE", "awaiting-first-change"}, {CLOCK_INTERVAL_AWAITING_SECOND_CHANGE, "CLOCK_INTERVAL_AWAITING_SECOND_CHANGE", "awaiting-second-change"}, {CLOCK_INTERVAL_ONE_SECOND, "CLOCK_INTERVAL_ONE_SECOND", "one-second"}, {CLOCK_INTERVAL_ONE_MINUTE, "CLOCK_INTERVAL_ONE_MINUTE", "one-minute"}, {0, NULL, NULL}};
	GType clock_interval_type_id;
	clock_interval_type_id = g_enum_register_static ("ClockInterval", values);
	return clock_interval_type_id;
}

static GType
clock_interval_get_type (void)
{
	static volatile gsize clock_interval_type_id__once = 0;
	if (g_once_init_enter (&clock_interval_type_id__once)) {
		GType clock_interval_type_id;
		clock_interval_type_id = clock_interval_get_type_once ();
		g_once_init_leave (&clock_interval_type_id__once, clock_interval_type_id);
	}
	return clock_interval_type_id__once;
}

static void
__lambda4_ (Clock* self)
{
	GtkToggleButton* _tmp0_;
#line 52 "../applets/core/clock/clock.vala"
	_tmp0_ = self->priv->clock;
#line 52 "../applets/core/clock/clock.vala"
	if (gtk_toggle_button_get_active (_tmp0_)) {
#line 166 "clock.c"
		GtkWindow* _tmp1_;
		GtkWindow* _tmp2_;
#line 54 "../applets/core/clock/clock.vala"
		_tmp1_ = clock_create_calendar (self);
#line 54 "../applets/core/clock/clock.vala"
		_g_object_unref0 (self->priv->calendar);
#line 54 "../applets/core/clock/clock.vala"
		self->priv->calendar = _tmp1_;
#line 55 "../applets/core/clock/clock.vala"
		_tmp2_ = self->priv->calendar;
#line 55 "../applets/core/clock/clock.vala"
		gtk_widget_show ((GtkWidget*) _tmp2_);
#line 179 "clock.c"
	} else {
		GtkWindow* _tmp3_;
#line 59 "../applets/core/clock/clock.vala"
		_tmp3_ = self->priv->calendar;
#line 59 "../applets/core/clock/clock.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp3_);
#line 60 "../applets/core/clock/clock.vala"
		_g_object_unref0 (self->priv->calendar);
#line 60 "../applets/core/clock/clock.vala"
		self->priv->calendar = NULL;
#line 190 "clock.c"
	}
}

static void
___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 51 "../applets/core/clock/clock.vala"
	__lambda4_ ((Clock*) self);
#line 200 "clock.c"
}

static void
__lambda5_ (Clock* self,
            GParamSpec* pspec)
{
	const gchar* _tmp0_;
#line 63 "../applets/core/clock/clock.vala"
	g_return_if_fail (pspec != NULL);
#line 64 "../applets/core/clock/clock.vala"
	_tmp0_ = pspec->name;
#line 64 "../applets/core/clock/clock.vala"
	if (g_strcmp0 (_tmp0_, CLOCK_BOLD) == 0) {
#line 214 "clock.c"
		GtkToggleButton* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 65 "../applets/core/clock/clock.vala"
		_tmp1_ = self->priv->clock;
#line 65 "../applets/core/clock/clock.vala"
		_tmp2_ = clock_get_css (self);
#line 65 "../applets/core/clock/clock.vala"
		_tmp3_ = _tmp2_;
#line 65 "../applets/core/clock/clock.vala"
		vala_panel_style_set_class ((GtkWidget*) _tmp1_, _tmp3_, "-vala-panel-font-weight", FALSE);
#line 65 "../applets/core/clock/clock.vala"
		_g_free0 (_tmp3_);
#line 228 "clock.c"
	} else {
		GDateTime* now = NULL;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		GtkWindow* _tmp6_;
#line 68 "../applets/core/clock/clock.vala"
		if (self->priv->timer != ((guint) 0)) {
#line 68 "../applets/core/clock/clock.vala"
			g_source_remove (self->priv->timer);
#line 238 "clock.c"
		}
#line 69 "../applets/core/clock/clock.vala"
		_g_free0 (self->priv->prev_clock_val);
#line 69 "../applets/core/clock/clock.vala"
		self->priv->prev_clock_val = NULL;
#line 70 "../applets/core/clock/clock.vala"
		self->priv->exp_count = 0;
#line 71 "../applets/core/clock/clock.vala"
		self->priv->exp_interval = CLOCK_INTERVAL_AWAITING_FIRST_CHANGE;
#line 72 "../applets/core/clock/clock.vala"
		_tmp4_ = g_date_time_new_now_local ();
#line 72 "../applets/core/clock/clock.vala"
		now = _tmp4_;
#line 73 "../applets/core/clock/clock.vala"
		_tmp5_ = now;
#line 73 "../applets/core/clock/clock.vala"
		clock_timer_set (self, _tmp5_);
#line 74 "../applets/core/clock/clock.vala"
		_tmp6_ = self->priv->calendar;
#line 74 "../applets/core/clock/clock.vala"
		if (_tmp6_ != NULL) {
#line 260 "clock.c"
			GtkWindow* _tmp7_;
#line 76 "../applets/core/clock/clock.vala"
			_tmp7_ = self->priv->calendar;
#line 76 "../applets/core/clock/clock.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp7_);
#line 77 "../applets/core/clock/clock.vala"
			_g_object_unref0 (self->priv->calendar);
#line 77 "../applets/core/clock/clock.vala"
			self->priv->calendar = NULL;
#line 270 "clock.c"
		}
#line 64 "../applets/core/clock/clock.vala"
		_g_date_time_unref0 (now);
#line 274 "clock.c"
	}
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 63 "../applets/core/clock/clock.vala"
	__lambda5_ ((Clock*) self, pspec);
#line 285 "clock.c"
}

static void
clock_real_constructed (GObject* base)
{
	Clock * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GtkToggleButton* _tmp9_;
	GtkToggleButton* _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkToggleButton* _tmp12_;
	GtkToggleButton* _tmp13_;
#line 43 "../applets/core/clock/clock.vala"
	self = (Clock*) base;
#line 45 "../applets/core/clock/clock.vala"
	_tmp0_ = vala_panel_applet_get_action_group ((ValaPanelApplet*) self);
#line 45 "../applets/core/clock/clock.vala"
	_tmp1_ = _tmp0_;
#line 45 "../applets/core/clock/clock.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, VALA_PANEL_APPLET_ACTION_CONFIGURE);
#line 45 "../applets/core/clock/clock.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL, TRUE);
#line 46 "../applets/core/clock/clock.vala"
	_tmp3_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 46 "../applets/core/clock/clock.vala"
	_tmp4_ = _tmp3_;
#line 46 "../applets/core/clock/clock.vala"
	g_settings_bind (_tmp4_, CLOCK_LABEL_FORMAT, (GObject*) self, CLOCK_LABEL_FORMAT, G_SETTINGS_BIND_GET);
#line 47 "../applets/core/clock/clock.vala"
	_tmp5_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 47 "../applets/core/clock/clock.vala"
	_tmp6_ = _tmp5_;
#line 47 "../applets/core/clock/clock.vala"
	g_settings_bind (_tmp6_, CLOCK_TIP_FORMAT, (GObject*) self, CLOCK_TIP_FORMAT, G_SETTINGS_BIND_GET);
#line 48 "../applets/core/clock/clock.vala"
	_tmp7_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 48 "../applets/core/clock/clock.vala"
	_tmp8_ = _tmp7_;
#line 48 "../applets/core/clock/clock.vala"
	g_settings_bind (_tmp8_, CLOCK_BOLD, (GObject*) self, CLOCK_BOLD, G_SETTINGS_BIND_GET);
#line 49 "../applets/core/clock/clock.vala"
	_tmp9_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 49 "../applets/core/clock/clock.vala"
	g_object_ref_sink (_tmp9_);
#line 49 "../applets/core/clock/clock.vala"
	_g_object_unref0 (self->priv->clock);
#line 49 "../applets/core/clock/clock.vala"
	self->priv->clock = _tmp9_;
#line 50 "../applets/core/clock/clock.vala"
	_tmp10_ = self->priv->clock;
#line 50 "../applets/core/clock/clock.vala"
	vala_panel_setup_button (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_button_get_type ()) ? ((GtkButton*) _tmp10_) : NULL, NULL, NULL);
#line 51 "../applets/core/clock/clock.vala"
	_tmp11_ = self->priv->clock;
#line 51 "../applets/core/clock/clock.vala"
	g_signal_connect_object (_tmp11_, "toggled", (GCallback) ___lambda4__gtk_toggle_button_toggled, self, 0);
#line 63 "../applets/core/clock/clock.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda5__g_object_notify, self, 0);
#line 81 "../applets/core/clock/clock.vala"
	_tmp12_ = self->priv->clock;
#line 81 "../applets/core/clock/clock.vala"
	gtk_widget_show ((GtkWidget*) _tmp12_);
#line 82 "../applets/core/clock/clock.vala"
	_tmp13_ = self->priv->clock;
#line 82 "../applets/core/clock/clock.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
#line 83 "../applets/core/clock/clock.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 362 "clock.c"
}

static GtkWidget*
clock_real_get_settings_ui (ValaPanelApplet* base)
{
	Clock * self;
	gchar** names = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gint names_length1;
	gint _names_size_;
	gchar** keys = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gint keys_length1;
	gint _keys_size_;
	ValaPanelConfiguratorType* types = NULL;
	ValaPanelConfiguratorType* _tmp9_;
	gint types_length1;
	gint _types_size_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* result;
#line 85 "../applets/core/clock/clock.vala"
	self = (Clock*) base;
#line 87 "../applets/core/clock/clock.vala"
	_tmp0_ = g_strdup (_ ("Clock Format"));
#line 87 "../applets/core/clock/clock.vala"
	_tmp1_ = g_strdup (_ ("Tooltip Format"));
#line 87 "../applets/core/clock/clock.vala"
	_tmp2_ = g_strdup (_ ("Format codes: man 3 strftime; %n for line break"));
#line 87 "../applets/core/clock/clock.vala"
	_tmp3_ = g_strdup (_ ("Bold font"));
#line 87 "../applets/core/clock/clock.vala"
	_tmp4_ = g_new0 (gchar*, 4 + 1);
#line 87 "../applets/core/clock/clock.vala"
	_tmp4_[0] = _tmp0_;
#line 87 "../applets/core/clock/clock.vala"
	_tmp4_[1] = _tmp1_;
#line 87 "../applets/core/clock/clock.vala"
	_tmp4_[2] = _tmp2_;
#line 87 "../applets/core/clock/clock.vala"
	_tmp4_[3] = _tmp3_;
#line 87 "../applets/core/clock/clock.vala"
	names = _tmp4_;
#line 87 "../applets/core/clock/clock.vala"
	names_length1 = 4;
#line 87 "../applets/core/clock/clock.vala"
	_names_size_ = names_length1;
#line 93 "../applets/core/clock/clock.vala"
	_tmp5_ = g_strdup (CLOCK_LABEL_FORMAT);
#line 93 "../applets/core/clock/clock.vala"
	_tmp6_ = g_strdup (CLOCK_TIP_FORMAT);
#line 93 "../applets/core/clock/clock.vala"
	_tmp7_ = g_strdup (CLOCK_BOLD);
#line 93 "../applets/core/clock/clock.vala"
	_tmp8_ = g_new0 (gchar*, 4 + 1);
#line 93 "../applets/core/clock/clock.vala"
	_tmp8_[0] = _tmp5_;
#line 93 "../applets/core/clock/clock.vala"
	_tmp8_[1] = _tmp6_;
#line 93 "../applets/core/clock/clock.vala"
	_tmp8_[2] = NULL;
#line 93 "../applets/core/clock/clock.vala"
	_tmp8_[3] = _tmp7_;
#line 93 "../applets/core/clock/clock.vala"
	keys = _tmp8_;
#line 93 "../applets/core/clock/clock.vala"
	keys_length1 = 4;
#line 93 "../applets/core/clock/clock.vala"
	_keys_size_ = keys_length1;
#line 99 "../applets/core/clock/clock.vala"
	_tmp9_ = g_new0 (ValaPanelConfiguratorType, 4);
#line 99 "../applets/core/clock/clock.vala"
	_tmp9_[0] = CONF_STR;
#line 99 "../applets/core/clock/clock.vala"
	_tmp9_[1] = CONF_STR;
#line 99 "../applets/core/clock/clock.vala"
	_tmp9_[2] = CONF_TRIM;
#line 99 "../applets/core/clock/clock.vala"
	_tmp9_[3] = CONF_BOOL;
#line 99 "../applets/core/clock/clock.vala"
	types = _tmp9_;
#line 99 "../applets/core/clock/clock.vala"
	types_length1 = 4;
#line 99 "../applets/core/clock/clock.vala"
	_types_size_ = types_length1;
#line 105 "../applets/core/clock/clock.vala"
	_tmp10_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 105 "../applets/core/clock/clock.vala"
	_tmp11_ = _tmp10_;
#line 105 "../applets/core/clock/clock.vala"
	_tmp12_ = vala_panel_generic_cfg_widget (_tmp11_, names, keys, types, (guint) types_length1);
#line 105 "../applets/core/clock/clock.vala"
	result = _tmp12_;
#line 105 "../applets/core/clock/clock.vala"
	types = (g_free (types), NULL);
#line 105 "../applets/core/clock/clock.vala"
	keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 105 "../applets/core/clock/clock.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 105 "../applets/core/clock/clock.vala"
	return result;
#line 472 "clock.c"
}

static void
clock_popup_position_helper (Clock* self,
                             GtkWidget* popup,
                             gint* x,
                             gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GtkAllocation pa = {0};
	GtkAllocation a = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp10_ = {0};
	GdkWindow* _tmp11_;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	GtkPositionType edge = 0;
	ValaPanelToplevel* _tmp16_;
	ValaPanelToplevel* _tmp17_;
	ValaPanelGravity _tmp18_;
	ValaPanelGravity _tmp19_;
	GdkMonitor* monitor = NULL;
	GdkDisplay* _tmp24_;
	GdkMonitor* _tmp25_;
	GdkRectangle _tmp26_ = {0};
	GtkAllocation _tmp27_;
	GtkAllocation _tmp28_;
	GtkAllocation _tmp29_;
	GtkAllocation _tmp30_;
	GtkAllocation _tmp31_;
	GtkAllocation _tmp32_;
	GtkAllocation _tmp33_;
	GtkAllocation _tmp34_;
#line 107 "../applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 107 "../applets/core/clock/clock.vala"
	g_return_if_fail (popup != NULL);
#line 112 "../applets/core/clock/clock.vala"
	gtk_widget_realize (popup);
#line 113 "../applets/core/clock/clock.vala"
	gtk_widget_get_allocation (popup, &_tmp0_);
#line 113 "../applets/core/clock/clock.vala"
	pa = _tmp0_;
#line 114 "../applets/core/clock/clock.vala"
	if (gtk_widget_is_toplevel (popup)) {
#line 519 "clock.c"
		GdkRectangle ext = {0};
		GdkWindow* _tmp1_;
		GdkRectangle _tmp2_ = {0};
		GdkRectangle _tmp3_;
		GdkRectangle _tmp4_;
#line 117 "../applets/core/clock/clock.vala"
		_tmp1_ = gtk_widget_get_window (popup);
#line 117 "../applets/core/clock/clock.vala"
		gdk_window_get_frame_extents (_tmp1_, &_tmp2_);
#line 117 "../applets/core/clock/clock.vala"
		ext = _tmp2_;
#line 118 "../applets/core/clock/clock.vala"
		_tmp3_ = ext;
#line 118 "../applets/core/clock/clock.vala"
		pa.width = _tmp3_.width;
#line 119 "../applets/core/clock/clock.vala"
		_tmp4_ = ext;
#line 119 "../applets/core/clock/clock.vala"
		pa.height = _tmp4_.height;
#line 539 "clock.c"
	}
#line 121 "../applets/core/clock/clock.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_menu_get_type ())) {
#line 543 "clock.c"
		gint min = 0;
		gint nat = 0;
		gint new_height = 0;
		GList* _tmp5_;
		GtkAllocation _tmp9_;
#line 123 "../applets/core/clock/clock.vala"
		new_height = 0;
#line 124 "../applets/core/clock/clock.vala"
		_tmp5_ = gtk_container_get_children ((GtkContainer*) (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_menu_get_type ()) ? ((GtkMenu*) popup) : NULL));
#line 553 "clock.c"
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
#line 124 "../applets/core/clock/clock.vala"
			item_collection = _tmp5_;
#line 124 "../applets/core/clock/clock.vala"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 561 "clock.c"
				GtkWidget* item = NULL;
#line 124 "../applets/core/clock/clock.vala"
				item = (GtkWidget*) item_it->data;
#line 565 "clock.c"
				{
					GtkWidget* _tmp6_;
					gint _tmp7_ = 0;
					gint _tmp8_ = 0;
#line 126 "../applets/core/clock/clock.vala"
					_tmp6_ = item;
#line 126 "../applets/core/clock/clock.vala"
					gtk_widget_get_preferred_height (_tmp6_, &_tmp7_, &_tmp8_);
#line 126 "../applets/core/clock/clock.vala"
					min = _tmp7_;
#line 126 "../applets/core/clock/clock.vala"
					nat = _tmp8_;
#line 127 "../applets/core/clock/clock.vala"
					new_height += nat;
#line 580 "clock.c"
				}
			}
#line 124 "../applets/core/clock/clock.vala"
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
#line 585 "clock.c"
		}
#line 129 "../applets/core/clock/clock.vala"
		_tmp9_ = pa;
#line 129 "../applets/core/clock/clock.vala"
		pa.height = MAX (_tmp9_.height, new_height);
#line 591 "clock.c"
	}
#line 131 "../applets/core/clock/clock.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp10_);
#line 131 "../applets/core/clock/clock.vala"
	a = _tmp10_;
#line 132 "../applets/core/clock/clock.vala"
	_tmp11_ = gtk_widget_get_window ((GtkWidget*) self);
#line 132 "../applets/core/clock/clock.vala"
	gdk_window_get_origin (_tmp11_, &_tmp12_, &_tmp13_);
#line 132 "../applets/core/clock/clock.vala"
	_vala_x = _tmp12_;
#line 132 "../applets/core/clock/clock.vala"
	_vala_y = _tmp13_;
#line 133 "../applets/core/clock/clock.vala"
	if (!gtk_widget_get_has_window ((GtkWidget*) self)) {
#line 607 "clock.c"
		GtkAllocation _tmp14_;
		GtkAllocation _tmp15_;
#line 135 "../applets/core/clock/clock.vala"
		_tmp14_ = a;
#line 135 "../applets/core/clock/clock.vala"
		_vala_x = _vala_x + _tmp14_.x;
#line 136 "../applets/core/clock/clock.vala"
		_tmp15_ = a;
#line 136 "../applets/core/clock/clock.vala"
		_vala_y = _vala_y + _tmp15_.y;
#line 618 "clock.c"
	}
#line 138 "../applets/core/clock/clock.vala"
	_tmp16_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 138 "../applets/core/clock/clock.vala"
	_tmp17_ = _tmp16_;
#line 138 "../applets/core/clock/clock.vala"
	g_object_get (_tmp17_, "panel-gravity", &_tmp18_, NULL);
#line 138 "../applets/core/clock/clock.vala"
	_tmp19_ = _tmp18_;
#line 138 "../applets/core/clock/clock.vala"
	edge = vala_panel_edge_from_gravity (_tmp19_);
#line 139 "../applets/core/clock/clock.vala"
	switch (edge) {
#line 139 "../applets/core/clock/clock.vala"
		case GTK_POS_TOP:
#line 634 "clock.c"
		{
			GtkAllocation _tmp20_;
#line 142 "../applets/core/clock/clock.vala"
			_tmp20_ = a;
#line 142 "../applets/core/clock/clock.vala"
			_vala_y = _vala_y + _tmp20_.height;
#line 143 "../applets/core/clock/clock.vala"
			break;
#line 643 "clock.c"
		}
#line 139 "../applets/core/clock/clock.vala"
		case GTK_POS_BOTTOM:
#line 647 "clock.c"
		{
			GtkAllocation _tmp21_;
#line 145 "../applets/core/clock/clock.vala"
			_tmp21_ = pa;
#line 145 "../applets/core/clock/clock.vala"
			_vala_y = _vala_y - _tmp21_.height;
#line 146 "../applets/core/clock/clock.vala"
			break;
#line 656 "clock.c"
		}
#line 139 "../applets/core/clock/clock.vala"
		case GTK_POS_LEFT:
#line 660 "clock.c"
		{
			GtkAllocation _tmp22_;
#line 148 "../applets/core/clock/clock.vala"
			_tmp22_ = a;
#line 148 "../applets/core/clock/clock.vala"
			_vala_x = _vala_x + _tmp22_.width;
#line 149 "../applets/core/clock/clock.vala"
			break;
#line 669 "clock.c"
		}
#line 139 "../applets/core/clock/clock.vala"
		case GTK_POS_RIGHT:
#line 673 "clock.c"
		{
			GtkAllocation _tmp23_;
#line 151 "../applets/core/clock/clock.vala"
			_tmp23_ = pa;
#line 151 "../applets/core/clock/clock.vala"
			_vala_x = _vala_x - _tmp23_.width;
#line 152 "../applets/core/clock/clock.vala"
			break;
#line 682 "clock.c"
		}
		default:
#line 139 "../applets/core/clock/clock.vala"
		break;
#line 687 "clock.c"
	}
#line 154 "../applets/core/clock/clock.vala"
	_tmp24_ = gtk_widget_get_display ((GtkWidget*) self);
#line 154 "../applets/core/clock/clock.vala"
	_tmp25_ = gdk_display_get_monitor_at_point (_tmp24_, _vala_x, _vala_y);
#line 154 "../applets/core/clock/clock.vala"
	monitor = _tmp25_;
#line 155 "../applets/core/clock/clock.vala"
	gdk_monitor_get_workarea (monitor, &_tmp26_);
#line 155 "../applets/core/clock/clock.vala"
	a = (GtkAllocation) _tmp26_;
#line 156 "../applets/core/clock/clock.vala"
	_tmp27_ = a;
#line 156 "../applets/core/clock/clock.vala"
	_tmp28_ = a;
#line 156 "../applets/core/clock/clock.vala"
	_tmp29_ = a;
#line 156 "../applets/core/clock/clock.vala"
	_tmp30_ = pa;
#line 156 "../applets/core/clock/clock.vala"
	_vala_x = CLAMP (_vala_x, _tmp27_.x, (_tmp28_.x + _tmp29_.width) - _tmp30_.width);
#line 157 "../applets/core/clock/clock.vala"
	_tmp31_ = a;
#line 157 "../applets/core/clock/clock.vala"
	_tmp32_ = a;
#line 157 "../applets/core/clock/clock.vala"
	_tmp33_ = a;
#line 157 "../applets/core/clock/clock.vala"
	_tmp34_ = pa;
#line 157 "../applets/core/clock/clock.vala"
	_vala_y = CLAMP (_vala_y, _tmp31_.y, (_tmp32_.y + _tmp33_.height) - _tmp34_.height);
#line 107 "../applets/core/clock/clock.vala"
	if (x) {
#line 107 "../applets/core/clock/clock.vala"
		*x = _vala_x;
#line 723 "clock.c"
	}
#line 107 "../applets/core/clock/clock.vala"
	if (y) {
#line 107 "../applets/core/clock/clock.vala"
		*y = _vala_y;
#line 729 "clock.c"
	}
}

static void
clock_set_popup_position (Clock* self,
                          GtkWidget* popup)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 159 "../applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 159 "../applets/core/clock/clock.vala"
	g_return_if_fail (popup != NULL);
#line 162 "../applets/core/clock/clock.vala"
	clock_popup_position_helper (self, popup, &_tmp0_, &_tmp1_);
#line 162 "../applets/core/clock/clock.vala"
	x = _tmp0_;
#line 162 "../applets/core/clock/clock.vala"
	y = _tmp1_;
#line 163 "../applets/core/clock/clock.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_window_get_type ())) {
#line 164 "../applets/core/clock/clock.vala"
		gtk_window_move (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_window_get_type ()) ? ((GtkWindow*) popup) : NULL, x, y);
#line 755 "clock.c"
	} else {
		GdkWindow* _tmp2_;
#line 166 "../applets/core/clock/clock.vala"
		_tmp2_ = gtk_widget_get_window (popup);
#line 166 "../applets/core/clock/clock.vala"
		gdk_window_move (_tmp2_, x, y);
#line 762 "clock.c"
	}
}

static gchar*
clock_get_css (Clock* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 168 "../applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 171 "../applets/core/clock/clock.vala"
	_tmp1_ = self->priv->_bold_font;
#line 171 "../applets/core/clock/clock.vala"
	if (_tmp1_) {
#line 171 "../applets/core/clock/clock.vala"
		_tmp0_ = "bold";
#line 786 "clock.c"
	} else {
#line 171 "../applets/core/clock/clock.vala"
		_tmp0_ = "normal";
#line 790 "clock.c"
	}
#line 170 "../applets/core/clock/clock.vala"
	_tmp2_ = g_strdup_printf (" font-weight: %s;\n", _tmp0_);
#line 170 "../applets/core/clock/clock.vala"
	_tmp3_ = _tmp2_;
#line 170 "../applets/core/clock/clock.vala"
	_tmp4_ = g_strconcat (".-vala-panel-font-weight{\n", _tmp3_, NULL);
#line 170 "../applets/core/clock/clock.vala"
	_tmp5_ = _tmp4_;
#line 170 "../applets/core/clock/clock.vala"
	_tmp6_ = g_strconcat (_tmp5_, "}", NULL);
#line 170 "../applets/core/clock/clock.vala"
	_tmp7_ = _tmp6_;
#line 170 "../applets/core/clock/clock.vala"
	_g_free0 (_tmp5_);
#line 170 "../applets/core/clock/clock.vala"
	_g_free0 (_tmp3_);
#line 170 "../applets/core/clock/clock.vala"
	result = _tmp7_;
#line 170 "../applets/core/clock/clock.vala"
	return result;
#line 812 "clock.c"
}

static GtkWindow*
clock_create_calendar (Clock* self)
{
	GtkWindow* win = NULL;
	GtkWindow* _tmp0_;
	GtkCalendar* calendar = NULL;
	GtkCalendar* _tmp1_;
	GDateTime* now = NULL;
	GDateTime* _tmp2_;
	ValaPanelToplevel* _tmp3_;
	ValaPanelToplevel* _tmp4_;
	ValaPanelToplevel* _tmp5_;
	ValaPanelToplevel* _tmp6_;
	GtkWindow* result;
#line 174 "../applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "../applets/core/clock/clock.vala"
	_tmp0_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_POPUP);
#line 177 "../applets/core/clock/clock.vala"
	g_object_ref_sink (_tmp0_);
#line 177 "../applets/core/clock/clock.vala"
	win = _tmp0_;
#line 178 "../applets/core/clock/clock.vala"
	gtk_window_set_default_size (win, 180, 180);
#line 179 "../applets/core/clock/clock.vala"
	gtk_container_set_border_width ((GtkContainer*) win, (guint) 5);
#line 181 "../applets/core/clock/clock.vala"
	_tmp1_ = (GtkCalendar*) gtk_calendar_new ();
#line 181 "../applets/core/clock/clock.vala"
	g_object_ref_sink (_tmp1_);
#line 181 "../applets/core/clock/clock.vala"
	calendar = _tmp1_;
#line 182 "../applets/core/clock/clock.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 182 "../applets/core/clock/clock.vala"
	now = _tmp2_;
#line 183 "../applets/core/clock/clock.vala"
	gtk_calendar_set_display_options (calendar, (GTK_CALENDAR_SHOW_WEEK_NUMBERS | GTK_CALENDAR_SHOW_DAY_NAMES) | GTK_CALENDAR_SHOW_HEADING);
#line 186 "../applets/core/clock/clock.vala"
	gtk_calendar_mark_day (calendar, (guint) g_date_time_get_day_of_month (now));
#line 187 "../applets/core/clock/clock.vala"
	gtk_container_add ((GtkContainer*) win, (GtkWidget*) calendar);
#line 189 "../applets/core/clock/clock.vala"
	gtk_window_set_type_hint (win, GDK_WINDOW_TYPE_HINT_UTILITY);
#line 190 "../applets/core/clock/clock.vala"
	_tmp3_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 190 "../applets/core/clock/clock.vala"
	_tmp4_ = _tmp3_;
#line 190 "../applets/core/clock/clock.vala"
	gtk_window_set_transient_for (win, (GtkWindow*) _tmp4_);
#line 191 "../applets/core/clock/clock.vala"
	_tmp5_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 191 "../applets/core/clock/clock.vala"
	_tmp6_ = _tmp5_;
#line 191 "../applets/core/clock/clock.vala"
	gtk_window_set_attached_to (win, (GtkWidget*) _tmp6_);
#line 192 "../applets/core/clock/clock.vala"
	gtk_widget_show ((GtkWidget*) calendar);
#line 193 "../applets/core/clock/clock.vala"
	clock_set_popup_position (self, (GtkWidget*) win);
#line 195 "../applets/core/clock/clock.vala"
	result = win;
#line 195 "../applets/core/clock/clock.vala"
	_g_date_time_unref0 (now);
#line 195 "../applets/core/clock/clock.vala"
	_g_object_unref0 (calendar);
#line 195 "../applets/core/clock/clock.vala"
	return result;
#line 883 "clock.c"
}

static gboolean
clock_update_display (Clock* self)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GSource* _tmp1_;
	GDateTime* _tmp2_;
	gchar* label = NULL;
	GDateTime* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* tooltip = NULL;
	GDateTime* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GtkToggleButton* _tmp9_;
	const gchar* _tmp10_;
	GtkToggleButton* _tmp11_;
	const gchar* _tmp12_;
	gboolean result;
#line 199 "../applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../applets/core/clock/clock.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 202 "../applets/core/clock/clock.vala"
	now = _tmp0_;
#line 204 "../applets/core/clock/clock.vala"
	_tmp1_ = g_main_current_source ();
#line 204 "../applets/core/clock/clock.vala"
	if (g_source_is_destroyed (_tmp1_)) {
#line 205 "../applets/core/clock/clock.vala"
		result = FALSE;
#line 205 "../applets/core/clock/clock.vala"
		_g_date_time_unref0 (now);
#line 205 "../applets/core/clock/clock.vala"
		return result;
#line 922 "clock.c"
	}
#line 207 "../applets/core/clock/clock.vala"
	_tmp2_ = now;
#line 207 "../applets/core/clock/clock.vala"
	clock_timer_set (self, _tmp2_);
#line 210 "../applets/core/clock/clock.vala"
	_tmp3_ = now;
#line 210 "../applets/core/clock/clock.vala"
	_tmp4_ = self->priv->_clock_format;
#line 210 "../applets/core/clock/clock.vala"
	_tmp5_ = g_date_time_format (_tmp3_, _tmp4_);
#line 210 "../applets/core/clock/clock.vala"
	label = _tmp5_;
#line 211 "../applets/core/clock/clock.vala"
	_tmp6_ = now;
#line 211 "../applets/core/clock/clock.vala"
	_tmp7_ = self->priv->_tooltip_format;
#line 211 "../applets/core/clock/clock.vala"
	_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 211 "../applets/core/clock/clock.vala"
	tooltip = _tmp8_;
#line 215 "../applets/core/clock/clock.vala"
	_tmp9_ = self->priv->clock;
#line 215 "../applets/core/clock/clock.vala"
	_tmp10_ = label;
#line 215 "../applets/core/clock/clock.vala"
	gtk_button_set_label ((GtkButton*) _tmp9_, _tmp10_);
#line 216 "../applets/core/clock/clock.vala"
	_tmp11_ = self->priv->clock;
#line 216 "../applets/core/clock/clock.vala"
	_tmp12_ = tooltip;
#line 216 "../applets/core/clock/clock.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp12_);
#line 221 "../applets/core/clock/clock.vala"
	if (self->priv->exp_interval < CLOCK_INTERVAL_ONE_SECOND) {
#line 958 "clock.c"
		const gchar* _tmp13_;
#line 223 "../applets/core/clock/clock.vala"
		_tmp13_ = self->priv->prev_clock_val;
#line 223 "../applets/core/clock/clock.vala"
		if (_tmp13_ == NULL) {
#line 964 "clock.c"
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 225 "../applets/core/clock/clock.vala"
			_tmp14_ = label;
#line 225 "../applets/core/clock/clock.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 225 "../applets/core/clock/clock.vala"
			_g_free0 (self->priv->prev_clock_val);
#line 225 "../applets/core/clock/clock.vala"
			self->priv->prev_clock_val = _tmp15_;
#line 975 "clock.c"
		} else {
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 228 "../applets/core/clock/clock.vala"
			_tmp16_ = self->priv->prev_clock_val;
#line 228 "../applets/core/clock/clock.vala"
			_tmp17_ = label;
#line 228 "../applets/core/clock/clock.vala"
			if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 230 "../applets/core/clock/clock.vala"
				self->priv->exp_count = self->priv->exp_count + 1;
#line 231 "../applets/core/clock/clock.vala"
				if (self->priv->exp_count > 3) {
#line 234 "../applets/core/clock/clock.vala"
					self->priv->exp_interval = CLOCK_INTERVAL_ONE_MINUTE;
#line 235 "../applets/core/clock/clock.vala"
					_g_free0 (self->priv->prev_clock_val);
#line 235 "../applets/core/clock/clock.vala"
					self->priv->prev_clock_val = NULL;
#line 995 "clock.c"
				}
			} else {
#line 238 "../applets/core/clock/clock.vala"
				if (self->priv->exp_interval == CLOCK_INTERVAL_AWAITING_FIRST_CHANGE) {
#line 1000 "clock.c"
					const gchar* _tmp18_;
					gchar* _tmp19_;
#line 242 "../applets/core/clock/clock.vala"
					self->priv->exp_interval = CLOCK_INTERVAL_AWAITING_SECOND_CHANGE;
#line 243 "../applets/core/clock/clock.vala"
					self->priv->exp_count = 0;
#line 244 "../applets/core/clock/clock.vala"
					_tmp18_ = label;
#line 244 "../applets/core/clock/clock.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 244 "../applets/core/clock/clock.vala"
					_g_free0 (self->priv->prev_clock_val);
#line 244 "../applets/core/clock/clock.vala"
					self->priv->prev_clock_val = _tmp19_;
#line 1015 "clock.c"
				} else {
					ClockInterval _tmp20_ = 0;
#line 249 "../applets/core/clock/clock.vala"
					if (self->priv->exp_count > 3) {
#line 249 "../applets/core/clock/clock.vala"
						_tmp20_ = CLOCK_INTERVAL_ONE_MINUTE;
#line 1022 "clock.c"
					} else {
#line 249 "../applets/core/clock/clock.vala"
						_tmp20_ = CLOCK_INTERVAL_ONE_SECOND;
#line 1026 "clock.c"
					}
#line 249 "../applets/core/clock/clock.vala"
					self->priv->exp_interval = _tmp20_;
#line 250 "../applets/core/clock/clock.vala"
					_g_free0 (self->priv->prev_clock_val);
#line 250 "../applets/core/clock/clock.vala"
					self->priv->prev_clock_val = NULL;
#line 1034 "clock.c"
				}
			}
		}
	}
#line 256 "../applets/core/clock/clock.vala"
	result = FALSE;
#line 256 "../applets/core/clock/clock.vala"
	_g_free0 (tooltip);
#line 256 "../applets/core/clock/clock.vala"
	_g_free0 (label);
#line 256 "../applets/core/clock/clock.vala"
	_g_date_time_unref0 (now);
#line 256 "../applets/core/clock/clock.vala"
	return result;
#line 1049 "clock.c"
}

static gboolean
_clock_update_display_gsource_func (gpointer self)
{
	gboolean result;
	result = clock_update_display ((Clock*) self);
#line 274 "../applets/core/clock/clock.vala"
	return result;
#line 1059 "clock.c"
}

static void
clock_timer_set (Clock* self,
                 GDateTime* current_time)
{
	guint microseconds = 0U;
#line 259 "../applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 259 "../applets/core/clock/clock.vala"
	g_return_if_fail (current_time != NULL);
#line 261 "../applets/core/clock/clock.vala"
	microseconds = (guint) 1000000;
#line 263 "../applets/core/clock/clock.vala"
	microseconds = (guint) (1000000 - g_date_time_get_microsecond (current_time));
#line 266 "../applets/core/clock/clock.vala"
	if (self->priv->exp_interval == CLOCK_INTERVAL_ONE_MINUTE) {
#line 1077 "clock.c"
		guint seconds = 0U;
#line 268 "../applets/core/clock/clock.vala"
		seconds = (guint) (60 - g_date_time_get_second (current_time));
#line 269 "../applets/core/clock/clock.vala"
		microseconds += seconds * 1000000;
#line 1083 "clock.c"
	}
#line 272 "../applets/core/clock/clock.vala"
	if (microseconds <= ((guint) 0)) {
#line 273 "../applets/core/clock/clock.vala"
		microseconds = (guint) 1000000;
#line 1089 "clock.c"
	}
#line 274 "../applets/core/clock/clock.vala"
	self->priv->timer = g_timeout_add_full (G_PRIORITY_DEFAULT, microseconds / 1000, _clock_update_display_gsource_func, g_object_ref (self), g_object_unref);
#line 1093 "clock.c"
}

Clock*
clock_construct (GType object_type)
{
	Clock * self = NULL;
#line 21 "../applets/core/clock/clock.vala"
	self = (Clock*) g_object_new (object_type, NULL);
#line 21 "../applets/core/clock/clock.vala"
	return self;
#line 1104 "clock.c"
}

Clock*
clock_new (void)
{
#line 21 "../applets/core/clock/clock.vala"
	return clock_construct (TYPE_CLOCK);
#line 1112 "clock.c"
}

const gchar*
clock_get_clock_format (Clock* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "../applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../applets/core/clock/clock.vala"
	_tmp0_ = self->priv->_clock_format;
#line 39 "../applets/core/clock/clock.vala"
	result = _tmp0_;
#line 39 "../applets/core/clock/clock.vala"
	return result;
#line 1128 "clock.c"
}

void
clock_set_clock_format (Clock* self,
                        const gchar* value)
{
	gchar* old_value;
#line 39 "../applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 39 "../applets/core/clock/clock.vala"
	old_value = clock_get_clock_format (self);
#line 39 "../applets/core/clock/clock.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1142 "clock.c"
		gchar* _tmp0_;
#line 39 "../applets/core/clock/clock.vala"
		_tmp0_ = g_strdup (value);
#line 39 "../applets/core/clock/clock.vala"
		_g_free0 (self->priv->_clock_format);
#line 39 "../applets/core/clock/clock.vala"
		self->priv->_clock_format = _tmp0_;
#line 39 "../applets/core/clock/clock.vala"
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_CLOCK_FORMAT_PROPERTY]);
#line 1152 "clock.c"
	}
}

const gchar*
clock_get_tooltip_format (Clock* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "../applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../applets/core/clock/clock.vala"
	_tmp0_ = self->priv->_tooltip_format;
#line 40 "../applets/core/clock/clock.vala"
	result = _tmp0_;
#line 40 "../applets/core/clock/clock.vala"
	return result;
#line 1169 "clock.c"
}

void
clock_set_tooltip_format (Clock* self,
                          const gchar* value)
{
	gchar* old_value;
#line 40 "../applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 40 "../applets/core/clock/clock.vala"
	old_value = clock_get_tooltip_format (self);
#line 40 "../applets/core/clock/clock.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1183 "clock.c"
		gchar* _tmp0_;
#line 40 "../applets/core/clock/clock.vala"
		_tmp0_ = g_strdup (value);
#line 40 "../applets/core/clock/clock.vala"
		_g_free0 (self->priv->_tooltip_format);
#line 40 "../applets/core/clock/clock.vala"
		self->priv->_tooltip_format = _tmp0_;
#line 40 "../applets/core/clock/clock.vala"
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_TOOLTIP_FORMAT_PROPERTY]);
#line 1193 "clock.c"
	}
}

gboolean
clock_get_bold_font (Clock* self)
{
	gboolean result;
#line 41 "../applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../applets/core/clock/clock.vala"
	result = self->priv->_bold_font;
#line 41 "../applets/core/clock/clock.vala"
	return result;
#line 1207 "clock.c"
}

void
clock_set_bold_font (Clock* self,
                     gboolean value)
{
	gboolean old_value;
#line 41 "../applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 41 "../applets/core/clock/clock.vala"
	old_value = clock_get_bold_font (self);
#line 41 "../applets/core/clock/clock.vala"
	if (old_value != value) {
#line 41 "../applets/core/clock/clock.vala"
		self->priv->_bold_font = value;
#line 41 "../applets/core/clock/clock.vala"
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_BOLD_FONT_PROPERTY]);
#line 1225 "clock.c"
	}
}

static void
clock_class_init (ClockClass * klass,
                  gpointer klass_data)
{
#line 21 "../applets/core/clock/clock.vala"
	clock_parent_class = g_type_class_peek_parent (klass);
#line 21 "../applets/core/clock/clock.vala"
	g_type_class_adjust_private_offset (klass, &Clock_private_offset);
#line 21 "../applets/core/clock/clock.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) clock_real_constructed;
#line 21 "../applets/core/clock/clock.vala"
	((ValaPanelAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (ValaPanelApplet*)) clock_real_get_settings_ui;
#line 21 "../applets/core/clock/clock.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_clock_get_property;
#line 21 "../applets/core/clock/clock.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_clock_set_property;
#line 21 "../applets/core/clock/clock.vala"
	G_OBJECT_CLASS (klass)->finalize = clock_finalize;
#line 21 "../applets/core/clock/clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_CLOCK_FORMAT_PROPERTY, clock_properties[CLOCK_CLOCK_FORMAT_PROPERTY] = g_param_spec_string ("clock-format", "clock-format", "clock-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../applets/core/clock/clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_TOOLTIP_FORMAT_PROPERTY, clock_properties[CLOCK_TOOLTIP_FORMAT_PROPERTY] = g_param_spec_string ("tooltip-format", "tooltip-format", "tooltip-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../applets/core/clock/clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_BOLD_FONT_PROPERTY, clock_properties[CLOCK_BOLD_FONT_PROPERTY] = g_param_spec_boolean ("bold-font", "bold-font", "bold-font", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1253 "clock.c"
}

static void
clock_instance_init (Clock * self,
                     gpointer klass)
{
#line 21 "../applets/core/clock/clock.vala"
	self->priv = clock_get_instance_private (self);
#line 1262 "clock.c"
}

static void
clock_finalize (GObject * obj)
{
	Clock * self;
#line 21 "../applets/core/clock/clock.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK, Clock);
#line 26 "../applets/core/clock/clock.vala"
	_g_object_unref0 (self->priv->clock);
#line 36 "../applets/core/clock/clock.vala"
	_g_free0 (self->priv->prev_clock_val);
#line 38 "../applets/core/clock/clock.vala"
	_g_object_unref0 (self->priv->calendar);
#line 39 "../applets/core/clock/clock.vala"
	_g_free0 (self->priv->_clock_format);
#line 40 "../applets/core/clock/clock.vala"
	_g_free0 (self->priv->_tooltip_format);
#line 21 "../applets/core/clock/clock.vala"
	G_OBJECT_CLASS (clock_parent_class)->finalize (obj);
#line 1283 "clock.c"
}

GType
clock_get_type (void)
{
	return clock_type_id;
}

GType
clock_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Clock), 0, (GInstanceInitFunc) clock_instance_init, NULL };
	clock_type_id = g_type_module_register_type (module, vala_panel_applet_get_type (), "Clock", &g_define_type_info, 0);
	Clock_private_offset = sizeof (ClockPrivate);
	return clock_type_id;
}

static void
_vala_clock_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK, Clock);
#line 21 "../applets/core/clock/clock.vala"
	switch (property_id) {
#line 21 "../applets/core/clock/clock.vala"
		case CLOCK_CLOCK_FORMAT_PROPERTY:
#line 21 "../applets/core/clock/clock.vala"
		g_value_set_string (value, clock_get_clock_format (self));
#line 21 "../applets/core/clock/clock.vala"
		break;
#line 21 "../applets/core/clock/clock.vala"
		case CLOCK_TOOLTIP_FORMAT_PROPERTY:
#line 21 "../applets/core/clock/clock.vala"
		g_value_set_string (value, clock_get_tooltip_format (self));
#line 21 "../applets/core/clock/clock.vala"
		break;
#line 21 "../applets/core/clock/clock.vala"
		case CLOCK_BOLD_FONT_PROPERTY:
#line 21 "../applets/core/clock/clock.vala"
		g_value_set_boolean (value, clock_get_bold_font (self));
#line 21 "../applets/core/clock/clock.vala"
		break;
#line 1329 "clock.c"
		default:
#line 21 "../applets/core/clock/clock.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../applets/core/clock/clock.vala"
		break;
#line 1335 "clock.c"
	}
}

static void
_vala_clock_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK, Clock);
#line 21 "../applets/core/clock/clock.vala"
	switch (property_id) {
#line 21 "../applets/core/clock/clock.vala"
		case CLOCK_CLOCK_FORMAT_PROPERTY:
#line 21 "../applets/core/clock/clock.vala"
		clock_set_clock_format (self, g_value_get_string (value));
#line 21 "../applets/core/clock/clock.vala"
		break;
#line 21 "../applets/core/clock/clock.vala"
		case CLOCK_TOOLTIP_FORMAT_PROPERTY:
#line 21 "../applets/core/clock/clock.vala"
		clock_set_tooltip_format (self, g_value_get_string (value));
#line 21 "../applets/core/clock/clock.vala"
		break;
#line 21 "../applets/core/clock/clock.vala"
		case CLOCK_BOLD_FONT_PROPERTY:
#line 21 "../applets/core/clock/clock.vala"
		clock_set_bold_font (self, g_value_get_boolean (value));
#line 21 "../applets/core/clock/clock.vala"
		break;
#line 1367 "clock.c"
		default:
#line 21 "../applets/core/clock/clock.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../applets/core/clock/clock.vala"
		break;
#line 1373 "clock.c"
	}
}

void
g_io_clock_load (GTypeModule* module)
{
#line 279 "../applets/core/clock/clock.vala"
	g_return_if_fail (module != NULL);
#line 279 "../applets/core/clock/clock.vala"
	clock_register_type (module);
#line 282 "../applets/core/clock/clock.vala"
	g_io_extension_point_implement (VALA_PANEL_APPLET_EXTENSION_POINT, TYPE_CLOCK, "org.valapanel.clock", 10);
#line 1386 "clock.c"
}

void
g_io_clock_unload (GIOModule* module)
{
#line 285 "../applets/core/clock/clock.vala"
	g_return_if_fail (module != NULL);
#line 1394 "clock.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

